﻿Imports MECMOD
Imports INFITF
Imports MECMOD.CatConstraintType
Imports MECMOD.CatConstraintMode
Imports PARTITF


Public Class Form1

Public CATIA As INFITF.Application

Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim myCATClass As New CATIAClass
    CATIA = myCATClass.GetCATIA()
    If CATIA Is Nothing Then
        MsgBox("CATIA konnte nicht gestartet werden!" + vbNewLine + "Das Programm wird beendet", MsgBoxStyle.Critical, "Fehler")
        End
    End If

    Me.OKButton.Enabled = False
End Sub

Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress

    Select Case Asc(e.KeyChar)
        Case 48 To 57, 8, 32
        Case Else
            e.Handled = True
    End Select

End Sub

Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
      If Len(Me.TextBox1.Text) > 0 Then
        Me.OKButton.Enabled = True
    Else
        Me.OKButton.Enabled = False
    End If
End Sub



Private Sub CancelBut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelBut.Click
    MsgBox("Das Programm wird jetzt beendet", MsgBoxStyle.Exclamation, "Abbruch durch Anwender")
    End
End Sub

Private Sub OKButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKButton.Click
    If CreateThePad() > 0 Then
        MsgBox("Es ist ein Fehler während der Erstellung des Pad´s aufgetretten", MsgBoxStyle.Critical, "Fehler")
        Me.TextBox1.Text = ""
    Else
        MsgBox("Das Pad wurde erfolgreich erstellt" + vbNewLine + "Die Dicke beträgt " & Me.TextBox1.Text & " mm" _
                , MsgBoxStyle.Information, "ERFOLGREICH")
        Me.TextBox1.Text = ""
    End If
End Sub



Public Function CreateThePad() As Integer

    Try
        '***Deklarationen
        Dim oDoc As PartDocument
        Dim oPart As Part
        Dim oBodies As Bodies
        Dim oBody As Body
        Dim oAxisSystems As AxisSystems
        Dim oAxisSystem As AxisSystem
        Dim oSketches As Sketches
        Dim oSketchPlaneRef As Reference
        Dim oSketch As Sketch
        Dim oFac2D As Factory2D
        Dim oGeoElements As GeometricElements
        Dim oAxis As Axis2D
        Dim HDicLine As Line2D
        Dim VDicLine As Line2D
        Dim oConstaints As Constraints
        Dim oShapeFac As ShapeFactory

        '***Neues Dokument (Part) erstellen und instanzieren
        oDoc = CATIA.Documents.Add("Part")
        oPart = oDoc.Part
        oBodies = oPart.Bodies
        oBody = oBodies.Item("PartBody")
        oPart.InWorkObject = oBody

        '***Refrenzfläche für Sketch erstellem
        oAxisSystems = oPart.AxisSystems
        oAxisSystem = oAxisSystems.Item("Absolute Axis System")

        '***Sketch erstellen
        oSketches = oBody.Sketches
        oSketchPlaneRef = oAxisSystem.YAxisDirection
        oSketch = oSketches.Add(oSketchPlaneRef)

        '***Sketch bearbeiten (Linien und Maße erstellen)
        oPart.InWorkObject = oSketch
        oFac2D = oSketch.OpenEdition()
        oGeoElements = oSketch.GeometricElements
        oAxis = oGeoElements.Item("AbsoluteAxis")
        oConstaints = oSketch.Constraints

        HDicLine = oAxis.GetItem("HDirection")
        HDicLine.ReportName = 1
        VDicLine = oAxis.GetItem("VDirection")
        VDicLine.ReportName = 2

        '***Startpunkt erstellen
        Dim oPoint1 As Point2D
        Dim oSketchRef1 As Reference
        Dim oSketchRef2 As Reference
        Dim oConstaint1 As Constraint

        oPoint1 = oFac2D.CreatePoint(-0.0#, 100.0#)
        oPoint1.ReportName = 3
        oSketchRef1 = oPart.CreateReferenceFromObject(oPoint1)
        oSketchRef2 = oPart.CreateReferenceFromObject(VDicLine)
        oConstaint1 = oConstaints.AddBiEltCst(catCstTypeOn, oSketchRef1, oSketchRef2)
        oConstaint1.Mode = catCstModeDrivingDimension

        '***Erste Linie erstellen
        Dim oPoint2 As Point2D
        Dim oLine1 As Line2D

        oPoint2 = oFac2D.CreatePoint(100.0#, 100.0#)
        oPoint2.ReportName = 4
        oLine1 = oFac2D.CreateLine(-0.0#, 100.0#, 100.0#, 100.0#)
        oLine1.ReportName = 5
        oLine1.StartPoint = oPoint1
        oLine1.EndPoint = oPoint2

        '***Zweite Linie erstellen
        Dim oPoint3 As Point2D
        Dim oLine2 As Line2D

        oPoint3 = oFac2D.CreatePoint(100.0#, 0.0#)
        oPoint3.ReportName = 6
        oLine2 = oFac2D.CreateLine(100.0#, 100.0#, 100.0#, -0.0#)
        oLine2.ReportName = 7
        oLine2.EndPoint = oPoint2
        oLine2.StartPoint = oPoint3

        '***Dritte Linie erstellen
        Dim oPoint4 As Point2D
        Dim oLine3 As Line2D

        oPoint4 = oFac2D.CreatePoint(0.0#, 0.0#)
        oPoint4.ReportName = 8
        oLine3 = oFac2D.CreateLine(100.0#, 0.0#, 0.0#, 0.0#)
        oLine3.ReportName = 9
        oLine3.StartPoint = oPoint3
        oLine3.EndPoint = oPoint4

        '***Vierte Linie erstellen
        Dim oLine4 As Line2D

        oLine4 = oFac2D.CreateLine(0.0#, 0.0#, 0.0#, 100.0#)
        oLine4.ReportName = 10
        oLine4.EndPoint = oPoint4
        oLine4.StartPoint = oPoint1

        '***Erste Bemaßungen erstellen
        Dim oConst1 As Constraint
        Dim oDimRef1 As Reference
        Dim oDimRef2 As Reference

        oDimRef1 = oPart.CreateReferenceFromObject(oLine1)
        oDimRef2 = oPart.CreateReferenceFromObject(HDicLine)
        oConst1 = oConstaints.AddBiEltCst(catCstTypeHorizontality, oDimRef1, oDimRef2)
        oConst1.Mode = catCstModeDrivingDimension

        '***Zweite Bemaßungen erstellen
        Dim oConst2 As Constraint
        Dim oDimRef3 As Reference
        Dim oDimRef4 As Reference

        oDimRef3 = oPart.CreateReferenceFromObject(oLine3)
        oDimRef4 = oPart.CreateReferenceFromObject(HDicLine)
        oConst2 = oConstaints.AddBiEltCst(catCstTypeHorizontality, oDimRef3, oDimRef4)
        oConst2.Mode = catCstModeDrivingDimension

        '***Dritte Bemaßungen erstellen
        Dim oConst3 As Constraint
        Dim oDimRef5 As Reference
        Dim oDimRef6 As Reference

        oDimRef5 = oPart.CreateReferenceFromObject(oLine2)
        oDimRef6 = oPart.CreateReferenceFromObject(VDicLine)
        oConst3 = oConstaints.AddBiEltCst(catCstTypeVerticality, oDimRef5, oDimRef6)
        oConst3.Mode = catCstModeDrivingDimension

        '***Vierte Bemaßungen erstellen
        Dim oConst4 As Constraint
        Dim oDimRef7 As Reference
        Dim oDimRef8 As Reference

        oDimRef7 = oPart.CreateReferenceFromObject(oLine4)
        oDimRef8 = oPart.CreateReferenceFromObject(VDicLine)
        oConst4 = oConstaints.AddBiEltCst(catCstTypeVerticality, oDimRef7, oDimRef8)
        oConst4.Mode = catCstModeDrivingDimension

        '***Fuenfte Bemaßungen erstellen
        Dim oConst5 As Constraint
        Dim oDimRef9 As Reference
        Dim oDimRef10 As Reference

        oDimRef9 = oPart.CreateReferenceFromObject(oPoint2)
        oDimRef10 = oPart.CreateReferenceFromObject(oLine1)
        oConst5 = oConstaints.AddBiEltCst(catCstTypeOn, oDimRef9, oDimRef10)
        oConst5.Mode = catCstModeDrivingDimension

        '***Sechste Bemaßungen erstellen
        Dim oConst6 As Constraint
        Dim oDimRef11 As Reference

        oDimRef11 = oPart.CreateReferenceFromObject(oLine1)
        oConst6 = oConstaints.AddMonoEltCst(catCstTypeLength, oDimRef11)
        oConst6.Mode = catCstModeDrivingDimension

        '***Siebte Bemaßungen erstellen
        Dim oConst7 As Constraint
        Dim oDimRef12 As Reference
        oDimRef12 = oPart.CreateReferenceFromObject(oLine2)
        oConst7 = oConstaints.AddMonoEltCst(catCstTypeLength, oDimRef12)
        oConst7.Mode = catCstModeDrivingDimension

        '***Sketch schließen
        oSketch.CloseEdition()

        '***Body in Arbeit defnieren und Part updaten
        oPart.InWorkObject = oBody
        oPart.Update()
        oPart.InWorkObject = oBody

        '***Block erzeugen
        Dim ResultPad As Pad

        oShapeFac = oPart.ShapeFactory
        ResultPad = oShapeFac.AddNewPad(oSketch, CDbl(Me.TextBox1.Text))

        '***Part updaten
        oPart.Update()
    Catch ErrorOnCreation As Exception
        Return 1
    End Try

    Return 0

End Function


End Class
